<?php
/*
  ----------------------------------------------------------------------
  GLPI - Gestionnaire Libre de Parc Informatique
  Copyright (C) 2003-2008 by the INDEPNET Development Team.
  
  http://indepnet.net/   http://glpi-project.org/
  ----------------------------------------------------------------------
  
  LICENSE
  
  This file is part of GLPI.
  
  GLPI is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  GLPI is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with GLPI; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file:
// ----------------------------------------------------------------------

if (!defined('GLPI_ROOT')){
	die("Sorry. You can't access directly to this file");
	}
	
function plugin_mass_ocs_import_Install() {
	$DB = new DB;
			
	// This index is provided in GLPI 0.71, not in 0.70, so we create it
	if (!isIndex("glpi_ocs_link", "last_ocs_update")) {
		$query = "ALTER TABLE `glpi_ocs_link` ADD INDEX `last_ocs_update` ( `ocs_server_id` , `last_ocs_update` )";
		$DB->query($query) or die($DB->error());
	}

	// plugin tables
	if (!TableExists("glpi_plugin_mass_ocs_import_config")) {
		$query="CREATE TABLE `glpi_plugin_mass_ocs_import_config` (
	  		 `ID` int(11) NOT NULL,
	  		 `enable_logging` int(1) NOT NULL default '1',
	  		 `thread_log_frequency` int(4) NOT NULL default '10',
	  		 `display_empty` int(1) NOT NULL default '1',
	  		 `delete_frequency` int(4) NOT NULL default '0',
	  		 `import_limit` int(11) NOT NULL default '0',
	  		 `default_ocs_server` int(11) NOT NULL default '-1',
		     `delay_refresh` varchar(4) NOT NULL default '0',
		     `delete_empty_frequency` int(4) NOT NULL default '0',
	 	     `warn_if_not_imported` int(1) NOT NULL default '0',
	 	     `not_imported_threshold` int(11) NOT NULL default '0',
	  		 PRIMARY KEY  (`ID`)
		) ENGINE=MyISAM";

		$DB->query($query) or die($DB->error());
			
		$query ="INSERT INTO `glpi_plugin_mass_ocs_import_config` (`ID`, `enable_logging`, `thread_log_frequency`, `display_empty`, `delete_frequency`, `import_limit`,`default_ocs_server` ) "
			." VALUES (1, 1, 50, 1, 2, 0,-1);";

		$DB->query($query) or die($DB->error());
	}
	 
 	if (!FieldExists("glpi_plugin_mass_ocs_import_config", "warn_if_not_imported")) {
 		$query = "ALTER TABLE `glpi_plugin_mass_ocs_import_config` ADD `warn_if_not_imported` int(1) NOT NULL default '0';";
 		$DB->query($query) or die($DB->error());
 	}
 	
 	if (!FieldExists("glpi_plugin_mass_ocs_import_config", "not_imported_threshold")) {
 		$query = "ALTER TABLE `glpi_plugin_mass_ocs_import_config` ADD `not_imported_threshold` int(11) NOT NULL default '0';";
 		$DB->query($query) or die($DB->error());
 	}
 	 	
	$query="CREATE TABLE IF NOT EXISTS `glpi_plugin_mass_ocs_import` (
	  `ID` int(11) NOT NULL auto_increment,
	  `thread_id` int(4) NOT NULL default '0',
	  `start_time` datetime NOT NULL default '0000-00-00 00:00:00',
	  `end_time` datetime NOT NULL default '0000-00-00 00:00:00',
	  `status` int(4) NOT NULL default 0,
	  `error_msg` text NOT NULL,
	  `process_id` int(11) NOT NULL default 0,
	  `imported_machines_number` int(11) NOT NULL default '0',
	  `synchronized_machines_number` int(11) NOT NULL default '0',
	  `failed_rules_machines_number` int(11) NOT NULL default '0',
	  `linked_machines_number` int(11) NOT NULL default '0',
	  `ocs_server_id` int(4) NOT NULL default '1',
	  `total_number_machines` int(11) NOT NULL default '0',
	  PRIMARY KEY (`ID`),
	  KEY `end_time` (`end_time`),
	  KEY `process_id` (`process_id`)
	) ENGINE=MyISAM";
	
	$DB->query($query) or die($DB->error());
	
	$query="CREATE TABLE IF NOT EXISTS `glpi_plugin_mass_ocs_import_not_imported` (
		`ID` INT( 11 ) NOT NULL  auto_increment,
		`ocs_id` INT( 11 ) NOT NULL ,
		`ocs_server_id` INT( 11 ) NOT NULL ,
		`deviceid` VARCHAR( 255 ) NOT NULL ,
		`useragent` VARCHAR( 255 ) NOT NULL ,
		`tag` VARCHAR( 255 ) NOT NULL ,
		`name` VARCHAR( 255 ) NOT NULL ,
		`ipaddr` VARCHAR( 255 ) NOT NULL ,
		`domain` VARCHAR( 255 ) NOT NULL ,
		`last_inventory` DATETIME ,
		PRIMARY KEY ( `ID` ),
		UNIQUE KEY `ocs_id` (`ocs_server_id`,`ocs_id`)
		) ENGINE = MYISAM";
		
	$DB->query($query) or die($DB->error());

 	if (!FieldExists("glpi_plugin_mass_ocs_import_not_imported", "useragent")) {
 		$query = "ALTER TABLE `glpi_plugin_mass_ocs_import_not_imported` ADD `useragent` VARCHAR(255) NOT NULL AFTER `deviceid`;";
 		$DB->query($query) or die($DB->error());
 	}
	
 	$query="CREATE TABLE IF NOT EXISTS `glpi_plugin_mass_ocs_import_servers` (
		  `ID` int(11) NOT NULL AUTO_INCREMENT,
		  `ocs_server_id` int(11) NOT NULL,
		  `max_ocs_id` int(11) DEFAULT NULL,
		  `max_glpi_date` datetime DEFAULT NULL,
		  PRIMARY KEY (`ID`),
		  UNIQUE KEY `ocs_server_id` (`ocs_server_id`)
		) ENGINE=MyISAM";
	
	$DB->query($query) or die($DB->error());
}


function plugin_mass_ocs_import_uninstall() {
	$DB = new DB;
		
	$query = "DROP TABLE  IF EXISTS `glpi_plugin_mass_ocs_import_servers`;";
		
	$DB->query($query) or die($DB->error());

	$query = "DROP TABLE  IF EXISTS `glpi_plugin_mass_ocs_import`;";
		
	$DB->query($query) or die($DB->error());
	
	$query = "DROP TABLE  IF EXISTS `glpi_plugin_mass_ocs_import_config`;";
	
	$DB->query($query) or die($DB->error());

	$query = "DROP TABLE  IF EXISTS `glpi_plugin_mass_ocs_import_not_imported`;";

	$DB->query($query) or die($DB->error());
}

function isScriptLocked()
{
	return file_exists(MASS_OCS_IMPORT_LOCKFILE);
}
function setScriptLock()
{
	$fp = fopen(MASS_OCS_IMPORT_LOCKFILE, "w+");
    fclose($fp);
}

function removeScriptLock()
{
	if (file_exists(MASS_OCS_IMPORT_LOCKFILE))
		unlink(MASS_OCS_IMPORT_LOCKFILE);
}

function getAllOcsServers()
{
	global $DB,$OCSMASSIMPORTLANG;
	
	$servers[-1] = $OCSMASSIMPORTLANG["config"][22];
	$sql = "SELECT ID,name FROM glpi_ocs_config";
	$result = $DB->query($sql);
	while ($conf = $DB->fetch_array($result))
		$servers[$conf["ID"]] = $conf["name"];
	
	return $servers;	
}

function plugin_mass_ocs_import_initSession()
{
	global $CFG_GLPI;
	
	if (TableExists("glpi_plugin_mass_ocs_import_servers") &&
		TableExists("glpi_plugin_mass_ocs_import") &&
		TableExists("glpi_plugin_mass_ocs_import_config") &&
		TableExists("glpi_plugin_mass_ocs_import_not_imported"))
			$_SESSION["glpi_plugin_mass_ocs_import_installed"]=1;
}

function plugin_mass_ocs_import_changeprofile()
{
	if(isset($_SESSION["glpi_plugin_mass_ocs_import_installed"]) && $_SESSION["glpi_plugin_mass_ocs_import_installed"]==1){
		if (haveRight("logs","r") || haveRight("ocsng","w"))
			$PLUGIN_HOOKS['menu_entry']['mass_ocs_import'] = true;
		else
			$PLUGIN_HOOKS['menu_entry']['mass_ocs_import'] = false;
	}
}
?>
