<?php
/*
 ----------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2008 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org/
 ----------------------------------------------------------------------

 LICENSE

	This file is part of GLPI.

    GLPI is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GLPI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GLPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ------------------------------------------------------------------------
*/

// Original Author of file: Walid Nouh (walid.nouh@atosorigin.com)
// Purpose of file:
// ----------------------------------------------------------------------
function logNotImported($ocs_server_id,$ocs_id)
{
	global $DBocs,$DB;
	
	checkOCSconnection($ocs_server_id);
	
	$query = "SELECT * FROM hardware, accountinfo WHERE accountinfo.HARDWARE_ID=hardware.ID AND ID='$ocs_id'";
	$result = $DBocs->query($query);
	if ($result && $DBocs->numrows($result)) {
		$line = $DBocs->fetch_array($result);
		$input["name"] = $line["NAME"];
		$input["domain"] = $line["WORKGROUP"];
		$input["tag"] = $line["TAG"];
		$input["deviceid"] = $line["DEVICEID"];
		$input["ipaddr"] = $line["IPADDR"];
		$input["ocs_server_id"] = $ocs_server_id;
		$input["ocs_id"] = $ocs_id;
		$input["last_inventory"] = $line["LASTCOME"];
		$input["useragent"]= $line["USERAGENT"];
		$notimported = new MassOCSImportLogNotImported;
		$notimported->add($input);
	}
}

function cleanNotImported($ocs_server_id,$ocs_id=-1)
{
	global $DB;

	$first = true;
	
	$sql = "DELETE FROM glpi_plugin_mass_ocs_import_not_imported";
	if ($ocs_server_id != -1) {
		$first = false;
		$sql .= " WHERE ocs_server_id=".$ocs_server_id;
	}

	if ($ocs_id != -1)
		$sql .= ((!$first)?" AND":" WHERE")."  ocs_id=".$ocs_id;

	$result = $DB->query($sql);	

	return ($result ? $DB->affected_rows() : -1);
}

function getOcsServerIDByOcsID($ocs_id)
{
	global $DB;
	$result = $DB->query("SELECT ocs_server_id FROM glpi_plugin_mass_ocs_import_not_imported WHERE ocs_id=".$ocs_id);
	if ($DB->num_fields($result) == 1)
		return $DB->result($result,0,"ocs_server_id");
	else
		return -1;	
}

function getNotImportedMachinesNumer()
{
	global $DB,$OCSMASSIMPORTLANG,$CFG_GLPI;
	
	$config = new MassOCSImportConfig;
	$config->getFromDB(1);
	if ($config->fields["warn_if_not_imported"])
	{
		$result = $DB->query("SELECT count(ocs_id) as cpt FROM glpi_plugin_mass_ocs_import_not_imported");
		$cpt = $DB->result($result,0,"cpt");
		if ($cpt>0)
		{
			echo "<div align='center'>";
			echo "<br><table class='tab_cadre' style='text-align:center' width='100%'>";
		    echo "<tr><th>".$OCSMASSIMPORTLANG["name"][1]." :  ".$OCSMASSIMPORTLANG["display"][2]."</th></tr>";
		    echo "</tr>";
		  	echo "<tr><td><a href=\"".$CFG_GLPI["root_doc"]."/plugins/mass_ocs_import/front/plugin_mass_ocs_import.notimported.php\">".$cpt. "</a> ".$OCSMASSIMPORTLANG["display"][3]."</td></tr>";
		    echo "</tr>";
			echo "</table></div>";	
		}	
	}
}
?>
