<?php
/*
 ----------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2008 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org/
 ----------------------------------------------------------------------

 LICENSE

	This file is part of GLPI.

    GLPI is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GLPI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GLPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ------------------------------------------------------------------------
*/

// Original Author of file: Walid Nouh (walid.nouh@atosorigin.com)
// Purpose of file:
// ----------------------------------------------------------------------
class ThreadRecord extends CommonDBTM{
	
    function ThreadRecord() {
    	$this->table="glpi_plugin_mass_ocs_import";
    	$this->type=-1;
    }

  function deleteThreadsByProcessId($process_id)
  {
  		global $DB;
  		$sql = "DELETE FROM ".$this->table." WHERE process_id=".$process_id;
  		$DB->query($sql);	
  }
  
  function showStat($duree, &$imported, &$synchronized, &$linked, &$failed, &$time)
  {
	global $OCSMASSIMPORTLANG;

	echo "<tr><th colspan='12'>" . $OCSMASSIMPORTLANG["common"][30];
	if ($duree < 9999) echo " (" . $duree . " " . $OCSMASSIMPORTLANG["time"][1] . ")";
	echo "</th></tr>";

	echo "<tr class='tab_bg_1'>";
	echo "<td align='right' colspan='6'>" . $OCSMASSIMPORTLANG["common"][25] . "<br />" . $OCSMASSIMPORTLANG["common"][26] . "<br />" . $OCSMASSIMPORTLANG["common"][27] . "<br />" . $OCSMASSIMPORTLANG["common"][28] . "</td>";
	echo "<td align='center'>" . $imported->GetMinimum() . "<br />" . $imported->GetMaximum() . "<br />" . round($imported->GetAverage(),2) . "<br />" . $imported->GetTotal() . "</td>";
	echo "<td align='center'>" . $synchronized->GetMinimum() . "<br />" . $synchronized->GetMaximum() . "<br />" . round($synchronized->GetAverage(),2) . "<br />" . $synchronized->GetTotal() . "</td>";
	echo "<td align='center'>" . $linked->GetMinimum() . "<br />" . $linked->GetMaximum() . "<br />" . round($linked->GetAverage(),2) . "<br />" . $linked->GetTotal() . "</td>";
	echo "<td align='center'>" . $failed->GetMinimum() . "<br />" . $failed->GetMaximum() . "<br />" . round($failed->GetAverage(),2) . "<br />&nbsp;</td>";
	echo "<td align='center'>" . timestampToString($time->GetMinimum()) . "<br />" . timestampToString($time->GetMaximum()) . "<br />" . 
		timestampToString(round($time->GetAverage())) . "<br />" . timestampToString($time->GetTotal()) . "</td>";
	if ($time->GetTotal()>0) {
		echo "<td align='center'>" . $OCSMASSIMPORTLANG["common"][29] . "<br />" . 
		round(($imported->GetTotal()+$synchronized->GetTotal()+$linked->GetTotal()+$failed->GetTotal())/$time->GetTotal(),2) . " pc/s</td>";
	}
	else	echo "<td>&nbsp;</td>";
	echo "</tr>\n";
   }

  function showProcesses($target)
  {
  		global $DB,$OCSMASSIMPORTLANG,$CFG_GLPI,$LANG;
  		
  		$canedit= haveRight("ocsng","w");
  		
  		$config = new MassOCSImportConfig;
  		$config->getFromDB(1);

		if ($config->fields["delete_frequency"]>0)  
			$minfreq=$config->fields["delete_frequency"];
		else
			$minfreq = 9999;

		if ($config->fields["delete_empty_frequency"]>0 && $config->fields["delete_empty_frequency"]<$minfreq) 
			$minfreq=$config->fields["delete_empty_frequency"];

  		$imported_number     = new MiniStat;
  		$synchronized_number = new MiniStat;
  		$linked_number       = new MiniStat;
  		$failed_number       = new MiniStat;
  		$process_time        = new MiniStat;
  		
		$sql = 	"SELECT ID, process_id, SUM(total_number_machines) AS total_machines,ocs_server_id, status, COUNT(*) AS threads_number, " .
			"MIN(start_time) AS starting_date, MAX(end_time) AS ending_date, TIME_TO_SEC(MAX(end_time))-TIME_TO_SEC(MIN(start_time)) AS duree, " .
		      	"SUM(imported_machines_number) AS imported_machines, SUM(synchronized_machines_number) AS synchronized_machines, " .
			"SUM(linked_machines_number) AS linked_machines, SUM(failed_rules_machines_number) AS failed_rules_machines, " .
			"end_time >= DATE_ADD(NOW(), INTERVAL -" . $minfreq . " HOUR) AS DoStat ".
		      	"FROM ".$this->table." GROUP BY process_id ORDER BY ID DESC";
	     	$result = $DB->query($sql);
      	
      	echo "<div id='barre_onglets'><ul id='onglet'>\n";
	echo "<li class='actif'><a href='" . $_SERVER["PHP_SELF"] . "'>&nbsp;". $OCSMASSIMPORTLANG["common"][1] ."&nbsp;</a></li>\n";
	echo "<li><a href='plugin_mass_ocs_import.notimported.php'>&nbsp;". $OCSMASSIMPORTLANG["common"][18] . "&nbsp;</a></li>\n";
	echo "<ul></div>\n";

      	echo "<div align='center'>";
		echo "<form name='processes' action=\"$target\" method=\"post\">";

		echo "<table class='tab_cadre_fixe' cellpadding='9'>";
		echo "<tr><th colspan='12'>" . $OCSMASSIMPORTLANG["common"][1] . "</th></tr>";
		echo "<tr>"; 
		echo"<th></th>";
		echo"<th></th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][10]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][4]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][2]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][3]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][5]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][6]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][19]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][18]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][7]."</th>";		
		echo"<th>".$OCSMASSIMPORTLANG["common"][11]."</th>";
		echo "</th></tr>\n";

		if ($DB->numrows($result)) {
		
			while ($thread = $DB->fetch_array($result)){
				if ($config->fields["display_empty"] || $thread["status"] != STATE_FINISHED || (!$config->fields["display_empty"] && $thread["total_machines"] > 0 && $thread["status"] == STATE_FINISHED))
				{
					if ($thread["DoStat"] && $thread["status"] == STATE_FINISHED) {
						$imported_number->AddValue($thread["imported_machines"]);
						$synchronized_number->AddValue($thread["synchronized_machines"]);
						$linked_number->AddValue($thread["linked_machines"]);
						$failed_number->AddValue($thread["failed_rules_machines"]);
						$process_time->AddValue($thread["duree"]);
					}
					else if ($imported_number->GetCount()>0) {
						$this->showStat($minfreq, $imported_number, $synchronized_number, $linked_number, $failed_number, $process_time);
						$imported_number->Reset();
					}
					echo "<tr class='tab_bg_1'>"; 
					
					if ($canedit){
						echo "<td width='10'>";
						$sel="";
						if (isset($_GET["select"])&&$_GET["select"]=="all") $sel="checked";
						echo "<input type='checkbox' name='item[".$thread["process_id"]."]' value='1' $sel>";
						echo "</td>";
					}
					else	 echo "<td width='10'>&nbsp;</td>";
				
					echo "<td align='center'><a href=\"./plugin_mass_ocs_import.process.form.php?pid=".$thread["process_id"]."\">".$thread["process_id"]."</a></td>";
					echo "<td align='center'>";
					
					switch(getProcessStatus($thread["process_id"]))
					{
						case STATE_FINISHED :
							echo "<img src='../pics/export.png'>";
							break;
						case STATE_RUNNING :
							echo "<img src='../pics/wait.png'>";
							break;
						case STATE_STARTED :
							echo "<img src='../pics/ok2.png'>";
							break;
					}
						
					echo "</td>";
					echo "<td align='center'>".$thread["threads_number"]."</td>";
					echo "<td align='center'>".convDateTime($thread["starting_date"])."</td>";
					echo "<td align='center'>".convDateTime($thread["ending_date"])."</td>";
					echo "<td align='center'>".$thread["imported_machines"]."</td>";
					echo "<td align='center'>".$thread["synchronized_machines"]."</td>";
					echo "<td align='center'>".$thread["linked_machines"]."</td>";
					echo "<td align='center'>".$thread["failed_rules_machines"]."</td>";
					
					echo "<td align='center'>";
					if ($thread["status"] == STATE_FINISHED)
						echo timestampToString($thread["duree"]);
					else
						echo "-----";	
					
					echo "</td>";
					
					echo "<td align='center'>"; 
					if ($thread["ocs_server_id"] != -1)
					{
						$ocsConfig = getOcsConf($thread["ocs_server_id"]);
						echo "<a href=\"".GLPI_ROOT."/front/ocsng.form.php?ID=".$ocsConfig["ID"]."\">".$ocsConfig["name"]."</a>";
					}
					else
						echo $OCSMASSIMPORTLANG["config"][22];
						
					echo "</td>";
					echo "</tr>\n";
				}	
			}
		}

		if ($imported_number->GetCount()>0) {
			$this->showStat($minfreq, $imported_number, $synchronized_number, $linked_number, $failed_number, $process_time);
		}
		echo "</table>";
		
		if ($canedit){
			echo "<div align='center'>";
			echo "<table width='80%'>";
			echo "<tr><td><img src=\"".$CFG_GLPI["root_doc"]."/pics/arrow-left.png\" alt=''></td><td align='center'><a onclick= \"if ( markAllRows('processes') ) return false;\" href='".$_SERVER['PHP_SELF']."?select=all'>".$LANG["buttons"][18]."</a></td>";
	
			echo "<td>/</td><td align='center'><a onclick= \"if ( unMarkAllRows('processes') ) return false;\" href='".$_SERVER['PHP_SELF']."?select=none'>".$LANG["buttons"][19]."</a>";
			echo "</td><td align='left' width='80%'>";
			echo "<input type='submit' name='delete_processes' value=\"".$LANG["buttons"][6]."\" class='submit'>";
			echo "</td>";
			echo "</table>";
	
			echo "</div>";
		}		
		
  }
  
  function showForm($target,$pid)
	{
		global $DB,$OCSMASSIMPORTLANG,$LANG;

		$config = new MassOCSImportConfig;
  		$config->getFromDB(1);
 
		$finished = true;
		$total = 0;		
		$sql = 	"SELECT ID, thread_id, status, total_number_machines, process_id, ". 
			"start_time AS starting_date, end_time AS ending_date, TIME_TO_SEC(end_time)-TIME_TO_SEC(start_time) AS duree, " .
	      		"imported_machines_number as imported_machines, synchronized_machines_number AS synchronized_machines, " .
	      		"failed_rules_machines_number AS failed_rules_machines, linked_machines_number AS linked_machines " .
	      		"FROM ".$this->table." WHERE process_id=".$pid." ORDER BY thread_id ASC";
	     $result = $DB->query($sql);
      
      	echo "<div id='barre_onglets'><ul id='onglet'>\n";
	echo "<li><a href='plugin_mass_ocs_import.processes.php'>&nbsp;". $OCSMASSIMPORTLANG["common"][1] . "&nbsp;</a></li>\n";
	echo "<li><a href='plugin_mass_ocs_import.notimported.php'>&nbsp;". $OCSMASSIMPORTLANG["common"][18] . "&nbsp;</a></li>\n";
	echo "<li class='actif'><a href='" . $_SERVER["REQUEST_URI"] . "'>&nbsp;". $OCSMASSIMPORTLANG["common"][8] ."&nbsp;</a></li>\n";
	echo "<ul></div>\n";
      	echo "<div align='center'>";
		echo "<form name=cas action=\"$target\" method=\"post\">";
			
		echo "<table class='tab_cadre_fixe' cellpadding='11'>";
		echo "<tr><th colspan='11'>" . $OCSMASSIMPORTLANG["common"][8] . " : ".$pid."</th></tr>";
		echo "<tr>"; 
		echo"<th>".$OCSMASSIMPORTLANG["common"][9]."</th>";		
		echo"<th>".$OCSMASSIMPORTLANG["common"][10]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][2]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][3]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][5]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][6]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][19]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][18]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][7]."</th>";
		echo"<th>".$OCSMASSIMPORTLANG["common"][17]."</th>";		
		echo"<th>".$OCSMASSIMPORTLANG["common"][15]."</th>";				
		echo "</th></tr>";

		if ($DB->numrows($result)) {
		
			while ($thread = $DB->fetch_array($result)){
				echo "<tr class='tab_bg_2'>"; 
				echo "<td align='center'>".$thread["thread_id"]."</td>";
				
				echo "<td align='center'>";
				
				switch($thread["status"])
				{
					case STATE_FINISHED :
						echo "<img src='../pics/export.png'>";
						break;						
					case STATE_RUNNING :
						echo "<img src='../pics/wait.png'>";
						$finished = false;
						break;
					case STATE_STARTED :
						echo "<img src='../pics/ok2.png'>";
						$finished = false;
						break;
				}
					
				echo "</td>";
				
				echo "<td align='center'>".convDateTime($thread["starting_date"])."</td>";
				echo "<td align='center'>".convDateTime($thread["ending_date"])."</td>";
				echo "<td align='center'>".$thread["imported_machines"]."</td>";
				echo "<td align='center'>".$thread["synchronized_machines"]."</td>";
				echo "<td align='center'>".$thread["linked_machines"]."</td>";
				echo "<td align='center'>".$thread["failed_rules_machines"]."</td>";
				
				echo "<td align='center'>";
				if ($thread["status"] == STATE_FINISHED)
					echo timestampToString($thread["duree"]);
				else
					echo "-----";	
				
				echo "</td>";

				echo "<td align='center'>".$thread["total_number_machines"]."</td>";
					
				if ($thread["total_number_machines"] == 0)
				{
					//Total number of machines is 0 because the thread had no machines to process
					if ($thread["status"] == STATE_FINISHED)
						$pourcent = 100;
					else
					//Total number of machines is 0 because the thread just started to process
						$pourcent = 0;
				}	
				else
					$pourcent = (100 * ($thread["imported_machines"] + $thread["synchronized_machines"])) / $thread["total_number_machines"];
				
				echo "<td align='center'>";
				printf("%.4s",$pourcent);
				echo "%</td>";
				
				echo "</tr>";
				$total += $thread["imported_machines"] + $thread["synchronized_machines"] + $thread["linked_machines"];
			}
		}
		echo "<tr class='tab_bg_2'><td colspan='11' align='center'>".$OCSMASSIMPORTLANG["common"][12]." : ".$total."</td></tr>";
		
		if ($config->fields["delay_refresh"] > 0 && !$finished)
			echo "<meta http-equiv=\"refresh\" content=\"".$config->fields["delay_refresh"]."\"; url=\"#\" />";

		//echo "<tr class='tab_bg_2'><td colspan='11' align='center'><input type='submit' name='submit' value=".$LANG["buttons"][13]."></td/></tr>";
		echo "</table>";
  }
}

?>