<?php


/*
 ----------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2008 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org/
 ----------------------------------------------------------------------

 LICENSE

	This file is part of GLPI.

    GLPI is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GLPI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GLPI; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ------------------------------------------------------------------------
*/

// Original Author of file: Walid Nouh (walid.nouh@atosorigin.com)
// Purpose of file:
// ----------------------------------------------------------------------
function getProcessStatus($pid) {
	global $DB;
	$sql = "SELECT status FROM glpi_plugin_mass_ocs_import WHERE process_id=" . $pid;
	$result = $DB->query($sql);
	$status = 0;
	$thread_number = 0;

	$thread_number = $DB->numrows($result);

	while ($thread = $DB->fetch_array($result)) {
		$status += $thread["status"];
	}

	if ($status < $thread_number * STATE_FINISHED)
		return STATE_RUNNING;
	else
		return STATE_FINISHED;
}

function deleteOldProcesses($delete_frequency,$delete_empty_frequency)
{
	global $DB;
	
	$nbdel=0;
	if ($delete_empty_frequency > 0)
	{
		$sql = "DELETE FROM glpi_plugin_mass_ocs_import WHERE status=" . STATE_FINISHED . " AND total_number_machines = 0 AND end_time < DATE_ADD(NOW(), INTERVAL -".$delete_empty_frequency." HOUR)";
		$result = $DB->query($sql);
		if ($result) $nbdel+=$DB->affected_rows();
	}

	
	//If $delete_frequency == 0 : don't delete anything
	if ($delete_frequency > 0)
	{
		$sql = "DELETE FROM glpi_plugin_mass_ocs_import WHERE status=" . STATE_FINISHED . " AND total_number_machines > 0 AND end_time < DATE_ADD(NOW(), INTERVAL -".$delete_frequency." HOUR)";
		$result = $DB->query($sql);
		if ($result) $nbdel+=$DB->affected_rows();
	}

	return $nbdel;
}

function getOcsServerIdsAndNames($ocs_servers)
{
	$servers = array();
	if (is_array($ocs_servers))
	{
		foreach ($servers as $server)
		{
			$ocsConfig = getOcsConf($server);
			$servers[$ocsConfig["ID"]] = $servers[$ocsConfig["name"]];
		}		 
	}
	else
	{
		$ocsConfig = getOcsConf($ocs_servers);
		$servers[$ocsConfig["ID"]] = $servers[$ocsConfig["name"]];
	}
	
	return $servers;
}

function cronDeleteThreads()
{
	$config = new MassOCSImportConfig;
	$config->getFromDB(1);
	return deleteOldProcesses($config->fields["delete_frequency"],$config->fields["delete_empty_frequency"]);
}

?>
